package hw5;

import gui.In;
import sun.misc.BASE64Decoder;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import java.io.*;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.SecureRandom;

public class SecureWriting {
    public static void main(String[] args) throws Exception {
         String uid = In.getString("enter uid");
        String pw = In.getPassword("enter pw");
        String concat = uid + pw;
        concat = concat.toLowerCase();
        System.out.println(concat);
        Key key;
        try {
            ObjectInputStream in = new ObjectInputStream(
                    new FileInputStream("Secret.ser"));
            key = (Key) in.readObject();
            in.close();
        }

        catch (FileNotFoundException fnfe) {
            KeyGenerator generator = KeyGenerator.getInstance("DES");
            generator.init(new SecureRandom());
            key = generator.generateKey();
            ObjectOutputStream out = new ObjectOutputStream(new
                    FileOutputStream("SecretKey.ser"));
            out.writeObject(key);
            out.close();
        }

        Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
        String plainText = In.getString("enter string to encode");
        String codeText = encode(cipher, key, plainText);
        System.out.println("codeText:"+codeText);
        decode(cipher, key,codeText);
    }

    private static void decode(Cipher cipher, Key key, String codeText) throws InvalidKeyException,
            IOException, IllegalBlockSizeException, BadPaddingException {

        cipher.init(Cipher.DECRYPT_MODE, key);
        BASE64Decoder decoder = new BASE64Decoder();
        byte[] raw = decoder.decodeBuffer(codeText);
        byte[] stringBytes = cipher.doFinal(raw);
        String result = new String(stringBytes, "UTF8");
        System.out.println(result);
    }

    private static String encode(Cipher cipher, Key key, String plainText)
            throws InvalidKeyException,
            UnsupportedEncodingException, IllegalBlockSizeException, BadPaddingException {
        cipher.init(Cipher.ENCRYPT_MODE, key);
        byte[] stringBytes = plainText.getBytes("UTF8");
        byte[] raw = cipher.doFinal(stringBytes);
        security.BASE64Encoder encoder = new security.BASE64Encoder();
        String base64 = encoder.encode(raw);
        return base64;
    }

}
